/**************************************************************************
**
** This file is part of Qt Creator
**
** Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
**
** Contact: Nokia Corporation (qt-info@nokia.com)
**
** Commercial Usage
**
** Licensees holding valid Qt Commercial licenses may use this file in
** accordance with the Qt Commercial License Agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and Nokia.
**
** GNU Lesser General Public License Usage
**
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 2.1 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU Lesser General Public License version 2.1 requirements
** will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** If you are unsure which license is appropriate for your use, please
** contact the sales department at http://qt.nokia.com/contact.
**
**************************************************************************/

#ifndef MAEMOGDBSETTINGSPAGE_H
#define MAEMOGDBSETTINGSPAGE_H

#include <coreplugin/dialogs/ioptionspage.h>
#include <QtGui/QWidget>

namespace Qt4ProjectManager{
    namespace Internal {

namespace Ui {
    class MaemoGdbWidget;
}

class MaemoGdbWidget : public QWidget {
    Q_OBJECT

public:
    MaemoGdbWidget(QWidget *parent = 0);
    ~MaemoGdbWidget();

    void saveSettings();
    QString searchKeywords() const;

protected:
    void changeEvent(QEvent *e);

private slots:
    void toogleGdbPathChooser(int state);

private:
    Ui::MaemoGdbWidget *ui;
};

class MaemoGdbSettingsPage : public Core::IOptionsPage
{
    Q_OBJECT

public:
    MaemoGdbSettingsPage(QObject *parent);
    ~MaemoGdbSettingsPage();

    virtual QString id() const;
    virtual QString displayName() const;
    virtual QString category() const;
    virtual QString displayCategory() const;
    virtual QIcon categoryIcon() const;
    virtual QWidget *createPage(QWidget *parent);
    virtual void apply();
    virtual void finish();
    virtual bool matches(const QString &) const;

signals:
    void updateGdbLocation();

private:
    MaemoGdbWidget *m_widget;
    QString m_searchKeywords;
};

    } // namespace Internal
} // namespace Qt4ProjectManager

#endif  // MAEMOGDBSETTINGSPAGE_H
